#include <stdio.h>
#include <algorithm>
using namespace std;
struct Point
{long long x,y;
 Point(){}
 Point(long long _x,long long _y):x(_x),y(_y){}
};
Point operator-(const Point &a,const Point &b)
{
return Point (a.x-b.x,a.y-b.y);
}

Point operator+(const Point &a,const Point &b)
{
return Point(a.x+b.x,a.y+b.y);
}


long long cross(const Point &a,const Point &b)
{
return a.x*b.y-a.y*b.x;
}

long long direction(const Point &a,const Point &b,const Point &c)
{
return cross(c-a,b-a);
}

bool PtCmp(const Point &a,const Point &b)
{
return direction(Point(0,0),a,b)<0;
}


Point P[500000];
int N;

Point G[500000];


Point Q[500000];
int GN;
void Push(const Point &a)
{
G[GN++]=a;
}
Point Top(){return G[GN-1];}
void Pop(){--GN;}

Point NextToTop()
{
return G[GN-2];
}

void Graham()
{
GN=0;
Point p=P[0];
for(int i=0;i<N;i++)
	{
	if(P[i].y<p.y) p=P[i];
	else if(P[i].y==p.y && P[i].x<p.x) p=P[i];
	}
for(int i=0;i<N;i++)
	{
	Q[i]=P[i]-p;
	}
sort(Q,Q+N,PtCmp);

Push(Q[0]);
Push(Q[1]);
Push(Q[2]);
for(int i=3;i<N;i++)
	{
	while( direction(NextToTop(),Top(),Q[i]) >=0 ) Pop();
	Push(Q[i]);
	}
}

long long dist(const Point &a,const Point &b)
{
long long dx=a.x-b.x;
long long dy=a.y-b.y;
return dx*dx+dy*dy;
}
long long Maxim()
{
long long m=0;
Graham();
for(int i=0;i<GN;i++)
	for(int j=i+1;j<GN;j++)
		{
		long long d=dist(G[i],G[j]);
		if(d>m) m=d;
		}
return m;
}

int main()
{
int t;
scanf("%d",&t);
while(t--)
	{
	scanf("%d",&N);
	int x,y;
	for(int i=0;i<N;i++)
		{
		scanf("%d%d",&x,&y);
		P[i]=Point(x,y);
		}	
	char out[30];
	long long d=Maxim();
	char *p=out;
	if(d==0) *(p++)='0';
	while(d)
		{
		*(p++)=d%10+'0';
		d/=10;
		}
	*p=0;
	reverse(out,p);
	puts(out);
	}
return 0;
}
